﻿using System.Collections;
using Com.Asreader.Lib;
using Com.Asreader.Lib.Device;
using Com.Asreader.Lib.Rfid.Event;
using Com.Asreader.Lib.Device.Type;
using Com.Asreader.Lib.Rfid.Type;
using Com.Asreader.Lib.Barcode;
using Com.Asreader.Lib.Rfid.Params;
using static AsReader251GMAUIDemo.Platforms.Droid.AsReader251GDefine;
using Java.Nio.Charset;
using Java.Interop;
using AsReader251GSDK;

namespace AsReader251GMAUIDemo.Platforms.Droid
{
    public class AsReader251GManager
    {
        public class MyAsReaderDeviceDelegate : Java.Lang.Object, IAsReaderEventListener
        {
            AsReader251GDelegate asReader251GDelegate = AsReader251GDelegate.sharedInstance();
            public MyAsReaderDeviceDelegate()
            {

            }
            public void OnStateChanged(AsReader p0, ConnectionState p1)
            {
                if (asReader251GDelegate.OnStateChanged != null)
                {
                    AsReader251G_ConnectionState status = (AsReader251G_ConnectionState)Convert.ToInt32(p1.State);
                    asReader251GDelegate.OnStateChanged(status);
                    if (status == AsReader251G_ConnectionState.Connected)
                    {
                        AsReader251GManager.sharedInstance().isConnect = true;
                    } else if (status == AsReader251G_ConnectionState.Disconnected)
                    {
                        AsReader251GManager.sharedInstance().isConnect = false;
                    }
                }
            }
            public void OnReadBarcode(AsReader p0, BarcodeType p1, string p2, string p3)
            {
                if (asReader251GDelegate.OnReadBarcode != null)
                {
                    string barcodeType = p1.ToString();
                    asReader251GDelegate.OnReadBarcode(barcodeType, p2, p3);
                }
            }
            public void OnReadTag(AsReader p0, ActionState p1, string p2, float p3, float p4, float p5)
            {
                if (asReader251GDelegate.OnReadTag != null)
                {
                    AsReader251G_ActionState status = (AsReader251G_ActionState)Convert.ToInt32(p1.Code);
                    asReader251GDelegate.OnReadTag(status, p2, p3, p4, p5);
                }
            }
            public void OnActionChanged(AsReader p0, ActionState p1)
            {
                if (asReader251GDelegate.OnActionChanged != null)
                {
                    AsReader251G_ActionState actionState = (AsReader251G_ActionState)Convert.ToInt32(p1.Code);
                    asReader251GDelegate.OnActionChanged(actionState);
                }
            }
            public void OnExceptionOccurred(AsReader p0, int p1)
            {
                if (asReader251GDelegate.OnExceptionOccurred != null)
                    asReader251GDelegate.OnExceptionOccurred(p1);
            }
            public void OnKeyEvent(AsReader p0, KeyType p1, KeyState p2)
            {
                if (asReader251GDelegate.OnKeyEvent != null)
                {
                    AsReader251G_KeyType keyType = (AsReader251G_KeyType)Convert.ToInt32(p1.GetKeyType());
                    AsReader251G_KeyState keyState = (AsReader251G_KeyState)Convert.ToInt32(p2.State);
                    asReader251GDelegate.OnKeyEvent(keyType, keyState);
                }
            }
            public void OnAccessResult(AsReader p0, ResultCode p1, ActionState p2, string p3, string p4, float p5, float p6, float p7)
            {

            }
            public void OnReadTagWithRFM(AsReader p0, ActionState p1, string p2, float p3, float p4, float p5, string[] p6)
            {

            }
            public void SetJniIdentityHashCode(int value)
            {

            }
            public void SetJniManagedPeerState(JniManagedPeerStates value)
            {

            }
            public void SetPeerReference(JniObjectReference reference)
            {

            }
            public void OnCommandComplete(AsReader p0, CommandType p1)
            {

            }
            public new void UnregisterFromRuntime()
            {

            }
        }

        public AsReader mReader;
        public Com.Asreader.Lib.Device.Device mDevice;
        private MyAsReaderDeviceDelegate myAsReaderDeviceDelegate;
        private int max;
        public bool isConnect;

        static AsReader251GManager uniqueInstance;
        static readonly object locker = new object();
        public static AsReader251GManager sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReader251GManager();
                    }
                }
            }
            return uniqueInstance;
        }

        public AsReader251GManager()
        {
            isConnect = false;
            mReader = AsReaderManager.Instance;
            myAsReaderDeviceDelegate = new MyAsReaderDeviceDelegate();
            mReader.SetEventListener(myAsReaderDeviceDelegate);
        }
        public void ConnectDevice()
        {
            if (mDevice == null)
            {
                mDevice = new DeviceUsbCdc(MainActivity.Instance);
            }
            mReader.ConnectDevice(mDevice);
        }
        public void DisconnectDevice()
        {
            if (mDevice != null)
            {
                mReader.DisconnectDevice();
            }
        }
        public AsReader251G_Charset AsReaderCharset
        {
            get
            {
                AsReader251G_Charset charSet = AsReader251G_Charset.ASCii;
                if (GetAsReaderStatus() == false)
                {
                    return charSet;
                }
                if (mReader.Charset == Charset.ForName("ASCII"))
                {
                    charSet = AsReader251G_Charset.ASCii;
                }
                else if (mReader.Charset == Charset.ForName("Shift_JIS"))
                {
                    charSet = AsReader251G_Charset.ShiftJIS;
                }
                else if (mReader.Charset == Charset.ForName("UTF-8"))
                {
                    charSet = AsReader251G_Charset.UTF8;
                }
                return charSet;
            }
            set
            {
                if (GetAsReaderStatus() == false)
                {
                    return;
                }
                Charset charSet = Charset.ForName("ASCII");
                if (value == AsReader251G_Charset.ASCii)
                {
                    charSet = Charset.ForName("ASCII");
                }
                else if (value == AsReader251G_Charset.ShiftJIS)
                {
                    charSet = Charset.ForName("Shift_JIS");
                }
                else if (value == AsReader251G_Charset.UTF8)
                {
                    charSet = Charset.ForName("UTF-8");
                }
                mReader.Charset = charSet;
            }
        }
        public int PowerGain
        {
            get
            {
                if (GetAsReaderStatus() == false)
                {
                    return 5;
                }
                return mReader.PowerGain;
            }
            set
            {
                if (GetAsReaderStatus() == false)
                {
                    return;
                }
                mReader.PowerGain = value;
            }
        }
        public string GetAPPVersion()
        {
            var activity = MainActivity.Instance;
            return activity.PackageManager.GetPackageInfo(activity.PackageName, 0).VersionName;
        }
        public string GetSDKVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.Version;
            }
        }
        public string GetFirmwareVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.FirmwareVersion;
            }
        }
        public string GetRFModuleVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.RFModuleVersion;
            }
        }
        public string GetSerialNumber()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.SerialNumber;
            }
        }
        public string GetGlobalBand()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.GlobalBand.ToString();
            }
        }
        public int GetBatteryStatus()
        {
            if (GetAsReaderStatus() == false)
            {
                return 0;
            }
            else
            {
                return mReader.BatteryStatus;
            }
        }
        public void StartDecode()
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.StartDecode();
            }
        }
        public void StopDecode()
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.StopDecode();
            }
        }
        public void Inventory()
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.Inventory();
            }
        }
        public void Stop()
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.Stop();
            }
        }
        public ArrayList GetPowerGainRange()
        {
            ArrayList mList = new ArrayList();
            if (GetAsReaderStatus() == true)
            {
                PowerRange powerRange = mReader.PowerGainRange;
                int min = powerRange.Min / 10;
                max = powerRange.Max / 10;

                for (int i = min; i <= max; i += 1)
                {
                    mList.Add(i.ToString());
                }
            }
            return mList;
        }
        public int GetPowerRangeMax()
        {
            return max;
        }
        public void SetContinuousMode(bool enabled)
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.ContinuousMode = enabled;
            }
        }
        public void Destroy()
        {
            if (GetAsReaderStatus() == true)
            {
                AsReaderManager.OnDestroy();
                if (mDevice != null)
                {
                    mDevice.Destroy();
                    mDevice = null;
                }
            }
        }
        public void SetBarcodeMode(bool isBarcodeMode)
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.SetBarcodeMode(isBarcodeMode);
            }
        }
        public bool GetAsReaderStatus()
        {
            if (mReader != null && mDevice != null && mDevice.State == ConnectionState.Connected && isConnect)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public string GetSDKMessage()
        {
            if (mReader != null)
            {
                return mReader.SDKMessage;
            }
            else
            {
                return "";
            }
        }
        public string GetAsReader251GSDKDLL()
        {
            return AsReader251GSDKDLL.DLLVersion();
        }
    }
}
