﻿using System.Collections;
using System.Collections.ObjectModel;
using AsReader251GMAUIDemo.Platforms.Droid;
using static AsReader251GMAUIDemo.Platforms.Droid.AsReader251GDefine;

namespace AsReader251GMAUIDemo;

public partial class RFIDInventoryPage : ContentPage
{
    private AsReader251GManager formManager;
    private AsReader251GDelegate asReader251GDelegate;
    ArrayList powerGainArray;
    int count;
    int powerGain;
    private AsReader251G_ActionState actionState;
    private ObservableCollection<ItemData> RFIDItems = new ObservableCollection<ItemData>();
    public ObservableCollection<ItemData> ItemData { get { return RFIDItems; } }
    private Dictionary<string, ItemData> dataDic = new Dictionary<string, ItemData>();

    public RFIDInventoryPage()
    {
        InitializeComponent();
        count = 0;
        powerGain = 5;
        RFIDActivityIndicator.IsRunning = false;
        actionState = AsReader251G_ActionState.Stop;
        formManager = AsReader251GManager.sharedInstance();
        asReader251GDelegate = AsReader251GDelegate.sharedInstance();
    }
    protected override void OnAppearing()
    {
        base.OnAppearing();
        StartActivityIndicator();
        RFIDListView.ItemsSource = RFIDItems;
        asReader251GDelegate.OnStateChanged = (AsReader251G_ConnectionState state) =>
        {
            OnStateChanged(state);
        };
        asReader251GDelegate.OnReadTag = (AsReader251G_ActionState p1, string p2, float p3, float p4, float p5) =>
        {
            OnReadTag(p1, p2, p3, p4, p5);
        };
        asReader251GDelegate.OnKeyEvent = (AsReader251G_KeyType p1, AsReader251G_KeyState p2) =>
        {
            OnKeyEvent(p1, p2);
        };
        asReader251GDelegate.OnExceptionOccurred = (int p1) =>
        {
            OnExceptionOccurred(p1);
        };
        asReader251GDelegate.OnActionChanged = (AsReader251G_ActionState p1) =>
        {
            OnActionChanged(p1);
        };
        Task.Run(() =>
        {
            try
            {
                powerGainArray = formManager.GetPowerGainRange();
                Thread.Sleep(500);
                powerGain = formManager.PowerGain;
            }
            catch (Exception)
            {
                powerGain = formManager.GetPowerRangeMax();
            }
            try
            {
                formManager.SetContinuousMode(true);
            }
            catch (Exception)
            {
            }
            MainThread.BeginInvokeOnMainThread(() =>
            {
                RescanTimePicker.Title = (powerGain / 10).ToString();
                if (powerGainArray != null)
                {
                    foreach (string power in powerGainArray)
                    {
                        RescanTimePicker.Items.Add(power);
                    }
                }
                StopActivityIndicator();
            });
        });
    }
    protected override void OnDisappearing()
    {
        base.OnDisappearing();
        formManager.Stop();
    }
    void StartScanButton_Clicked(object sender, EventArgs e)
    {
        if (actionState == AsReader251G_ActionState.Inventory)
        {
            formManager.Stop();
        }
        else if (actionState == AsReader251G_ActionState.Stop)
        {
            formManager.Inventory();
        }
    }
    void ClearScanButton_Clicked(object sender, EventArgs e)
    {
        count = 0;
        CountLabel.Text = count.ToString();
        dataDic.Clear();
        RFIDItems.Clear();
    }
    void OnPickerSelectedIndexChanged(object sender, EventArgs e)
    {
        var picker = (Picker)sender;
        int selectedIndex = picker.SelectedIndex;
        if (selectedIndex != -1)
        {
            string powerGain = picker.Items[selectedIndex];
            RescanTimePicker.Title = powerGain;
            formManager.PowerGain = int.Parse(powerGain) * 10;
        }
    }
    private void OnStateChanged(AsReader251G_ConnectionState state)
    {
        if (state != AsReader251G_ConnectionState.Connected)
        {
            MainThread.BeginInvokeOnMainThread(() =>
            {
                Navigation.PopAsync();
            });
        }
    }
    private void OnReadTag(AsReader251G_ActionState p1, string p2, float p3, float p4, float p5)
    {
        ItemData InventoryDataChanged;
        if (dataDic.ContainsKey(p2))
        {
            InventoryDataChanged = dataDic[p2];
            InventoryDataChanged.Count++;
            dataDic[p2] = InventoryDataChanged;
        }
        else
        {
            int nowCount = dataDic.Count;
            InventoryDataChanged = new ItemData("0", p2, 1);
            dataDic.Add(p2, InventoryDataChanged);
            RFIDItems.Add(InventoryDataChanged);
        }
        count++;
        MainThread.BeginInvokeOnMainThread(() =>
        {
            RFIDListView.ItemsSource = null;
            RFIDListView.ItemsSource = RFIDItems;
            CountLabel.Text = count.ToString();
        });
    }
    private void OnKeyEvent(AsReader251G_KeyType p1, AsReader251G_KeyState p2)
    {
        if (p1 == AsReader251G_KeyType.Trigger)
        {
            if (p2 == AsReader251G_KeyState.KeyDown)
            {
                formManager.Inventory();
            }
            else
            {
                formManager.Stop();
            }
        }
        else
        {
            formManager.SetBarcodeMode(false);
        }
    }
    private void OnExceptionOccurred(int p1)
    {
        MainThread.BeginInvokeOnMainThread(() =>
        {
            DisplayAlert("Error", p1.ToString(), "Confirm");
        });
    }
    private void OnActionChanged(AsReader251G_ActionState p1)
    {
        MainThread.BeginInvokeOnMainThread(() =>
        {
            if (p1 == AsReader251G_ActionState.Inventory)
            {
                actionState = AsReader251G_ActionState.Inventory;
                StartScanButton.Text = "Stop Scan";
            }
            else if (p1 == AsReader251G_ActionState.Stop)
            {
                actionState = AsReader251G_ActionState.Stop;
                StartScanButton.Text = "Inventory";
            }
        });
    }
    public void StartActivityIndicator()
    {
        RFIDActivityIndicator.IsRunning = true;
        RFIDListView.IsEnabled = false;
        StartScanButton.IsEnabled = false;
        ClearScanButton.IsEnabled = false;
        RescanTimePicker.IsEnabled = false;
    }
    public void StopActivityIndicator()
    {
        RFIDActivityIndicator.IsRunning = false;
        RFIDListView.IsEnabled = true;
        StartScanButton.IsEnabled = true;
        ClearScanButton.IsEnabled = true;
        RescanTimePicker.IsEnabled = true;
    }
}
